(* File generated from abstract0.idl *)

(* This file is part of the APRON Library, released under LGPL license.
   Please read the COPYING file packaged in the distribution  *)

type t

external set_gc : int -> unit
	= "camlidl_abstract0_ap_abstract0_set_gc"

(* ********************************************************************** *)
(** {2 General management} *)
(* ********************************************************************** *)
(* ============================================================ *)
(** {3 Memory} *)
(* ============================================================ *)
external copy : Manager.t -> t -> t
	= "camlidl_abstract0_ap_abstract0_copy"

external size : Manager.t -> t -> int
	= "camlidl_abstract0_ap_abstract0_size"

(* ============================================================ *)
(** {3 Control of internal representation} *)
(* ============================================================ *)
external minimize : Manager.t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_minimize"

external canonicalize : Manager.t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_canonicalize"

external approximate : Manager.t -> t -> int -> unit
	= "camlidl_abstract0_ap_abstract0_approximate"

external is_minimal : Manager.t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_minimal"

external is_canonical : Manager.t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_canonical"

(* ============================================================ *)
(** {3 Printing} *)
(* ============================================================ *)
external fdump : Manager.t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_fdump"

(* ============================================================ *)
(** {3 Serialization} *)
(* ============================================================ *)
(* ********************************************************************** *)
(** {2 Constructor, accessors, tests and property extraction} *)
(* ********************************************************************** *)
(* ============================================================ *)
(** {3 Basic constructors} *)
(* ============================================================ *)
external bottom : Manager.t -> int -> int -> t
	= "camlidl_abstract0_ap_abstract0_bottom"

external top : Manager.t -> int -> int -> t
	= "camlidl_abstract0_ap_abstract0_top"

external of_box : Manager.t -> int -> int -> Interval.t array -> t
	= "camlidl_abstract0_ap_abstract0_of_box"

external of_lincons_array : Manager.t -> int -> int -> Lincons0.t array -> t
	= "camlidl_abstract0_ap_abstract0_of_lincons_array"

(* ============================================================ *)
(** {3 Accessors} *)
(* ============================================================ *)
external dimension : Manager.t -> t -> Dim.dimension
	= "camlidl_abstract0_ap_abstract0_dimension"

external manager : t -> Manager.t
	= "camlidl_abstract0_ap_abstract0_manager"

(* ============================================================ *)
(** {3 Tests} *)
(* ============================================================ *)
external is_bottom : Manager.t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_bottom"

external is_top : Manager.t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_top"

external is_leq : Manager.t -> t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_leq"

external is_eq : Manager.t -> t -> t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_eq"

external sat_lincons : Manager.t -> t -> Lincons0.t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_sat_lincons"

external sat_interval : Manager.t -> t -> Dim.t -> Interval.t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_sat_interval"

external is_dimension_unconstrained : Manager.t -> t -> Dim.t -> Manager.tbool
	= "camlidl_abstract0_ap_abstract0_is_dimension_unconstrained"

(* ============================================================ *)
(** {3 Extraction of properties} *)
(* ============================================================ *)
external bound_dimension : Manager.t -> t -> Dim.t -> Interval.t
	= "camlidl_abstract0_ap_abstract0_bound_dimension"

external bound_linexpr : Manager.t -> t -> Linexpr0.t -> Interval.t
	= "camlidl_abstract0_ap_abstract0_bound_linexpr"

external to_box : Manager.t -> t -> Interval.t array
	= "camlidl_abstract0_ap_abstract0_to_box"

external to_lincons_array : Manager.t -> t -> Lincons0.t array
	= "camlidl_abstract0_ap_abstract0_to_lincons_array"

external to_generator_array : Manager.t -> t -> Generator0.t array
	= "camlidl_abstract0_ap_abstract0_to_generator_array"

(* ********************************************************************** *)
(** {2 Operations} *)
(* ********************************************************************** *)
(* ============================================================ *)
(** {3 Meet and Join} *)
(* ============================================================ *)
external meet : Manager.t -> t -> t -> t
	= "camlidl_abstract0_ap_abstract0_meet"

external meet_array : Manager.t -> t array -> t
	= "camlidl_abstract0_ap_abstract0_meet_array"

external meet_lincons_array : Manager.t -> t -> Lincons0.t array -> t
	= "camlidl_abstract0_ap_abstract0_meet_lincons_array"

external join : Manager.t -> t -> t -> t
	= "camlidl_abstract0_ap_abstract0_join"

external join_array : Manager.t -> t array -> t
	= "camlidl_abstract0_ap_abstract0_join_array"

external add_ray_array : Manager.t -> t -> Generator0.t array -> t
	= "camlidl_abstract0_ap_abstract0_add_ray_array"

external meet_with : Manager.t -> t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_meet_with"

external meet_lincons_array_with : Manager.t -> t -> Lincons0.t array -> unit
	= "camlidl_abstract0_ap_abstract0_meet_lincons_array_with"

external join_with : Manager.t -> t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_join_with"

external add_ray_array_with : Manager.t -> t -> Generator0.t array -> unit
	= "camlidl_abstract0_ap_abstract0_add_ray_array_with"

(* ============================================================ *)
(** {3 Assignements and Substitutions} *)
(* ============================================================ *)
external assign_linexpr : Manager.t -> t -> Dim.t -> Linexpr0.t -> t option -> t
	= "camlidl_abstract0_ap_abstract0_assign_linexpr"

external substitute_linexpr : Manager.t -> t -> Dim.t -> Linexpr0.t -> t option -> t
	= "camlidl_abstract0_ap_abstract0_substitute_linexpr"

external assign_linexpr_array : Manager.t -> t -> Dim.t array -> Linexpr0.t array -> t option -> t
	= "camlidl_abstract0_ap_abstract0_assign_linexpr_array"

external substitute_linexpr_array : Manager.t -> t -> Dim.t array -> Linexpr0.t array -> t option -> t
	= "camlidl_abstract0_ap_abstract0_substitute_linexpr_array"

external assign_linexpr_with : Manager.t -> t -> Dim.t -> Linexpr0.t -> t option -> unit
	= "camlidl_abstract0_ap_abstract0_assign_linexpr_with"

external substitute_linexpr_with : Manager.t -> t -> Dim.t -> Linexpr0.t -> t option -> unit
	= "camlidl_abstract0_ap_abstract0_substitute_linexpr_with"

external assign_linexpr_array_with : Manager.t -> t -> Dim.t array -> Linexpr0.t array -> t option -> unit
	= "camlidl_abstract0_ap_abstract0_assign_linexpr_array_with"

external substitute_linexpr_array_with : Manager.t -> t -> Dim.t array -> Linexpr0.t array -> t option -> unit
	= "camlidl_abstract0_ap_abstract0_substitute_linexpr_array_with"

(* ============================================================ *)
(** {3 Projections} *)
(* ============================================================ *)
external forget_array : Manager.t -> t -> Dim.t array -> bool -> t
	= "camlidl_abstract0_ap_abstract0_forget_array"

external forget_array_with : Manager.t -> t -> Dim.t array -> bool -> unit
	= "camlidl_abstract0_ap_abstract0_forget_array_with"

(* ============================================================ *)
(** {3 Change and permutation of dimensions} *)
(* ============================================================ *)


external add_dimensions : Manager.t -> t -> Dim.change -> bool -> t
	= "camlidl_abstract0_ap_abstract0_add_dimensions"

external remove_dimensions : Manager.t -> t -> Dim.change -> t
	= "camlidl_abstract0_ap_abstract0_remove_dimensions"

external permute_dimensions : Manager.t -> t -> Dim.perm option -> t
	= "camlidl_abstract0_ap_abstract0_permute_dimensions"

external add_dimensions_with : Manager.t -> t -> Dim.change -> bool -> unit
	= "camlidl_abstract0_ap_abstract0_add_dimensions_with"

external remove_dimensions_with : Manager.t -> t -> Dim.change -> unit
	= "camlidl_abstract0_ap_abstract0_remove_dimensions_with"

external permute_dimensions_with : Manager.t -> t -> Dim.perm option -> unit
	= "camlidl_abstract0_ap_abstract0_permute_dimensions_with"

(* ============================================================ *)
(** {3 Expansion and folding of dimensions} *)
(* ============================================================ *)
external expand : Manager.t -> t -> Dim.t -> int -> t
	= "camlidl_abstract0_ap_abstract0_expand"

external fold : Manager.t -> t -> Dim.t array -> t
	= "camlidl_abstract0_ap_abstract0_fold"

external expand_with : Manager.t -> t -> Dim.t -> int -> unit
	= "camlidl_abstract0_ap_abstract0_expand_with"

external fold_with : Manager.t -> t -> Dim.t array -> unit
	= "camlidl_abstract0_ap_abstract0_fold_with"

(* ============================================================ *)
(** {3 Widening} *)
(* ============================================================ *)
external widening : Manager.t -> t -> t -> t
	= "camlidl_abstract0_ap_abstract0_widening"

external widening_threshold : Manager.t -> t -> t -> Lincons0.t array -> t
	= "camlidl_abstract0_ap_abstract0_widening_threshold"

(* ============================================================ *)
(** {3 Closure operation} *)
(* ============================================================ *)
external closure : Manager.t -> t -> t
	= "camlidl_abstract0_ap_abstract0_closure"

external closure_with : Manager.t -> t -> unit
	= "camlidl_abstract0_ap_abstract0_closure_with"


let print_array
?(first=("[|@[":(unit,Format.formatter,unit) format))
?(sep = (";@ ":(unit,Format.formatter,unit) format))
?(last = ("@]|]":(unit,Format.formatter,unit) format))
(print_elt: Format.formatter -> 'a -> unit)
(fmt:Format.formatter)
(array: 'a array)
: unit
=
if array=[||] then begin
Format.fprintf fmt first;
Format.fprintf fmt last;
end
else begin
Format.fprintf fmt first;
let first = ref true in
Array.iter
(begin fun e ->
if !first then first := false else Format.fprintf fmt sep;
print_elt fmt e
end)
array
;
Format.fprintf fmt last;
end

let print assoc fmt a =
let man = manager a in
if is_bottom man a = Manager.True then
Format.pp_print_string fmt "bottom"
else if is_top man a = Manager.True then
Format.pp_print_string fmt "top"
else begin
let tab = to_lincons_array man a in
print_array (Lincons0.print assoc) fmt tab;
end

