/* File generated from manager.idl */

/* This file is part of the APRON Library, released under LGPL license.
  Please read the COPYING file packaged in the distribution  */

#include <stddef.h>
#include <string.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include <caml/fail.h>
#include <caml/callback.h>
#ifdef Custom_tag
#include <caml/custom.h>
#include <caml/bigarray.h>
#endif
#include <caml/camlidlruntime.h>


#include <limits.h>
#include "ap_manager.h"
#include "apron_caml.h"

#define False tbool_false 
#define True tbool_true 
#define Top tbool_top 

#define Funid_unknown    AP_FUNID_UNKNOWN
#define Funid_copy    AP_FUNID_COPY
#define Funid_free    AP_FUNID_FREE
#define Funid_asize    AP_FUNID_ASIZE
#define Funid_minimize    AP_FUNID_MINIMIZE
#define Funid_canonicalize    AP_FUNID_CANONICALIZE
#define Funid_approximate    AP_FUNID_APPROXIMATE
#define Funid_is_minimal    AP_FUNID_IS_MINIMAL
#define Funid_is_canonical    AP_FUNID_IS_CANONICAL
#define Funid_fprint    AP_FUNID_FPRINT
#define Funid_fprintdiff    AP_FUNID_FPRINTDIFF
#define Funid_fdump    AP_FUNID_FDUMP
#define Funid_serialize_raw    AP_FUNID_SERIALIZE_RAW
#define Funid_deserialize_raw    AP_FUNID_DESERIALIZE_RAW
#define Funid_bottom    AP_FUNID_BOTTOM
#define Funid_top    AP_FUNID_TOP
#define Funid_of_box    AP_FUNID_OF_BOX
#define Funid_of_lincons_array    AP_FUNID_OF_LINCONS_ARRAY
#define Funid_dimension    AP_FUNID_DIMENSION
#define Funid_is_bottom    AP_FUNID_IS_BOTTOM
#define Funid_is_top    AP_FUNID_IS_TOP
#define Funid_is_leq    AP_FUNID_IS_LEQ
#define Funid_is_eq    AP_FUNID_IS_EQ
#define Funid_is_dimension_unconstrained    AP_FUNID_IS_DIMENSION_UNCONSTRAINED
#define Funid_sat_interval    AP_FUNID_SAT_INTERVAL
#define Funid_sat_lincons    AP_FUNID_SAT_LINCONS
#define Funid_bound_dimension    AP_FUNID_BOUND_DIMENSION
#define Funid_bound_linexpr    AP_FUNID_BOUND_LINEXPR
#define Funid_to_box    AP_FUNID_TO_BOX
#define Funid_to_lincons_array    AP_FUNID_TO_LINCONS_ARRAY
#define Funid_to_generator_array    AP_FUNID_TO_GENERATOR_ARRAY
#define Funid_meet    AP_FUNID_MEET
#define Funid_meet_array    AP_FUNID_MEET_ARRAY
#define Funid_meet_lincons_array    AP_FUNID_MEET_LINCONS_ARRAY
#define Funid_join    AP_FUNID_JOIN
#define Funid_join_array    AP_FUNID_JOIN_ARRAY
#define Funid_add_ray_array    AP_FUNID_ADD_RAY_ARRAY
#define Funid_assign_linexpr    AP_FUNID_ASSIGN_LINEXPR
#define Funid_assign_linexpr_array    AP_FUNID_ASSIGN_LINEXPR_ARRAY
#define Funid_substitute_linexpr    AP_FUNID_SUBSTITUTE_LINEXPR
#define Funid_substitute_linexpr_array    AP_FUNID_SUBSTITUTE_LINEXPR_ARRAY
#define Funid_add_dimensions    AP_FUNID_ADD_DIMENSIONS
#define Funid_remove_dimensions    AP_FUNID_REMOVE_DIMENSIONS
#define Funid_permute_dimensions    AP_FUNID_PERMUTE_DIMENSIONS
#define Funid_forget_array    AP_FUNID_FORGET_ARRAY
#define Funid_expand    AP_FUNID_EXPAND
#define Funid_fold    AP_FUNID_FOLD
#define Funid_widening    AP_FUNID_WIDENING
#define Funid_closure    AP_FUNID_CLOSURE
#define Funid_size    AP_FUNID_SIZE
#define Funid_change_environment    AP_FUNID_CHANGE_ENVIRONMENT
#define Funid_rename_array    AP_FUNID_RENAME_ARRAY
#define Funid_size2    AP_FUNID_SIZE2

#define Exc_none    AP_EXC_NONE
#define Exc_timeout    AP_EXC_TIMEOUT
#define Exc_out_of_space    AP_EXC_OUT_OF_SPACE
#define Exc_overflow    AP_EXC_OVERFLOW
#define Exc_invalid_argument    AP_EXC_INVALID_ARGUMENT
#define Exc_not_implemented    AP_EXC_NOT_IMPLEMENTED
#define Exc_size    AP_EXC_SIZE

int camlidl_transl_table_manager_enum_1[3] = {
  False,
  True,
  Top,
};

int camlidl_ml2c_manager_enum_tbool_t(value _v1)
{
  int _c2;
  _c2 = camlidl_transl_table_manager_enum_1[Int_val(_v1)];
  return _c2;
}

value camlidl_c2ml_manager_enum_tbool_t(int _c1)
{
  value _v2;
  switch(_c1) {
  case False: _v2 = Val_int(0); break;
  case True: _v2 = Val_int(1); break;
  case Top: _v2 = Val_int(2); break;
  default: invalid_argument("enum tbool_t: bad enum tbool_t value");
  }
  return _v2;
}

int camlidl_transl_table_manager_enum_2[53] = {
  Funid_unknown,
  Funid_copy,
  Funid_free,
  Funid_asize,
  Funid_minimize,
  Funid_canonicalize,
  Funid_approximate,
  Funid_is_minimal,
  Funid_is_canonical,
  Funid_fprint,
  Funid_fprintdiff,
  Funid_fdump,
  Funid_serialize_raw,
  Funid_deserialize_raw,
  Funid_bottom,
  Funid_top,
  Funid_of_box,
  Funid_of_lincons_array,
  Funid_dimension,
  Funid_is_bottom,
  Funid_is_top,
  Funid_is_leq,
  Funid_is_eq,
  Funid_is_dimension_unconstrained,
  Funid_sat_interval,
  Funid_sat_lincons,
  Funid_bound_dimension,
  Funid_bound_linexpr,
  Funid_to_box,
  Funid_to_lincons_array,
  Funid_to_generator_array,
  Funid_meet,
  Funid_meet_array,
  Funid_meet_lincons_array,
  Funid_join,
  Funid_join_array,
  Funid_add_ray_array,
  Funid_assign_linexpr,
  Funid_assign_linexpr_array,
  Funid_substitute_linexpr,
  Funid_substitute_linexpr_array,
  Funid_add_dimensions,
  Funid_remove_dimensions,
  Funid_permute_dimensions,
  Funid_forget_array,
  Funid_expand,
  Funid_fold,
  Funid_widening,
  Funid_closure,
  Funid_size,
  Funid_change_environment,
  Funid_rename_array,
  Funid_size2,
};

int camlidl_ml2c_manager_enum_ap_funid_t(value _v1)
{
  int _c2;
  _c2 = camlidl_transl_table_manager_enum_2[Int_val(_v1)];
  return _c2;
}

value camlidl_c2ml_manager_enum_ap_funid_t(int _c1)
{
  value _v2;
  _v2 = camlidl_find_enum(_c1, camlidl_transl_table_manager_enum_2, 53, "enum ap_funid_t: bad enum ap_funid_t value");
  return _v2;
}

int camlidl_transl_table_manager_enum_3[7] = {
  Exc_none,
  Exc_timeout,
  Exc_out_of_space,
  Exc_overflow,
  Exc_invalid_argument,
  Exc_not_implemented,
  Exc_size,
};

int camlidl_ml2c_manager_enum_ap_exc_t(value _v1)
{
  int _c2;
  _c2 = camlidl_transl_table_manager_enum_3[Int_val(_v1)];
  return _c2;
}

value camlidl_c2ml_manager_enum_ap_exc_t(int _c1)
{
  value _v2;
  _v2 = camlidl_find_enum(_c1, camlidl_transl_table_manager_enum_3, 7, "enum ap_exc_t: bad enum ap_exc_t value");
  return _v2;
}

void camlidl_ml2c_manager_struct_ap_funopt_t(value _v1, struct ap_funopt_t * _c2, camlidl_ctx _ctx)
{
  value _v3;
  value _v4;
  value _v5;
  value _v6;
  value _v7;
  value _v8;
  value _v9;
  _v3 = Field(_v1, 0);
  (*_c2).algorithm = Int_val(_v3);
  _v4 = Field(_v1, 1);
  (*_c2).approx_before = Int_val(_v4);
  _v5 = Field(_v1, 2);
  (*_c2).approx_after = Int_val(_v5);
  _v6 = Field(_v1, 3);
  (*_c2).timeout = Int_val(_v6);
  _v7 = Field(_v1, 4);
  (*_c2).max_object_size = Int_val(_v7);
  _v8 = Field(_v1, 5);
  (*_c2).flag_exact_wanted = Int_val(_v8);
  _v9 = Field(_v1, 6);
  (*_c2).flag_best_wanted = Int_val(_v9);
}

value camlidl_c2ml_manager_struct_ap_funopt_t(struct ap_funopt_t * _c1, camlidl_ctx _ctx)
{
  value _v2;
  value _v3[7];
  memset(_v3, 0, 7 * sizeof(value));
  Begin_roots_block(_v3, 7)
    _v3[0] = Val_int((*_c1).algorithm);
    _v3[1] = Val_int((*_c1).approx_before);
    _v3[2] = Val_int((*_c1).approx_after);
    _v3[3] = Val_int((*_c1).timeout);
    _v3[4] = Val_int((*_c1).max_object_size);
    _v3[5] = Val_int((*_c1).flag_exact_wanted);
    _v3[6] = Val_int((*_c1).flag_best_wanted);
    _v2 = camlidl_alloc_small(7, 0);
    { mlsize_t _c4;
      for (_c4 = 0; _c4 < 7; _c4++) Field(_v2, _c4) = _v3[_c4];
    }
  End_roots()
  return _v2;
}

void camlidl_ml2c_manager_struct_ap_exclog_t(value _v1, struct ap_exclog_t * _c2, camlidl_ctx _ctx)
{
  value _v3;
  value _v4;
  value _v5;
  _v3 = Field(_v1, 0);
  (*_c2).exn = camlidl_ml2c_manager_enum_ap_exc_t(_v3);
  _v4 = Field(_v1, 1);
  (*_c2).funid = camlidl_ml2c_manager_enum_ap_funid_t(_v4);
  _v5 = Field(_v1, 2);
  (*_c2).msg = camlidl_malloc_string(_v5, _ctx);
}

value camlidl_c2ml_manager_struct_ap_exclog_t(struct ap_exclog_t * _c1, camlidl_ctx _ctx)
{
  value _v2;
  value _v3[3];
  _v3[0] = _v3[1] = _v3[2] = 0;
  Begin_roots_block(_v3, 3)
    _v3[0] = camlidl_c2ml_manager_enum_ap_exc_t((*_c1).exn);
    _v3[1] = camlidl_c2ml_manager_enum_ap_funid_t((*_c1).funid);
    _v3[2] = copy_string((*_c1).msg);
    _v2 = camlidl_alloc_small(3, 0);
    Field(_v2, 0) = _v3[0];
    Field(_v2, 1) = _v3[1];
    Field(_v2, 2) = _v3[2];
  End_roots()
  return _v2;
}

void camlidl_ml2c_manager_ap_manager_ptr(value _v1, ap_manager_ptr * _c2, camlidl_ctx _ctx)
{
  *_c2 = *((ap_manager_ptr *) Data_custom_val(_v1));
}

static void camlidl_finalize_manager_ap_manager_ptr(value v)
{
  camlidl_apron_manager_ptr_finalize((ap_manager_ptr *) Data_custom_val(v));
}
struct custom_operations camlidl_cops_manager_ap_manager_ptr = {
  NULL,
  camlidl_finalize_manager_ap_manager_ptr,
  custom_compare_default,
  custom_hash_default,
  custom_serialize_default,
  custom_deserialize_default
};

value camlidl_c2ml_manager_ap_manager_ptr(ap_manager_ptr * _c2, camlidl_ctx _ctx)
{
value _v1;
  _v1 = alloc_custom(&camlidl_cops_manager_ap_manager_ptr, sizeof(ap_manager_ptr), 0, 1);
  *((ap_manager_ptr *) Data_custom_val(_v1)) = *_c2;
  return _v1;
}

value camlidl_manager_ap_manager_get_library(
	value _v_man)
{
  ap_manager_ptr man; /*in*/
  char const *_res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  _res = ap_manager_get_library(man);
  _vres = copy_string(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_manager_get_version(
	value _v_man)
{
  ap_manager_ptr man; /*in*/
  char const *_res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  _res = ap_manager_get_version(man);
  _vres = copy_string(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_funopt_make(value _unit)
{
  struct ap_funopt_t *x; /*out*/
  struct ap_funopt_t _c1;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  x = &_c1;
  /* begin user-supplied calling sequence */
ap_funopt_init(x);
  /* end user-supplied calling sequence */
  _vres = camlidl_c2ml_manager_struct_ap_funopt_t(&*x, _ctx);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_manager_get_funopt(
	value _v_man,
	value _v_funid)
{
  ap_manager_ptr man; /*in*/
  int funid; /*in*/
  struct ap_funopt_t _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  funid = camlidl_ml2c_manager_enum_ap_funid_t(_v_funid);
  _res = ap_manager_get_funopt(man, funid);
  _vres = camlidl_c2ml_manager_struct_ap_funopt_t(&_res, _ctx);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_manager_set_funopt(
	value _v_man,
	value _v_funid,
	value _v_funopt)
{
  ap_manager_ptr man; /*in*/
  int funid; /*in*/
  struct ap_funopt_t *funopt; /*in*/
  struct ap_funopt_t _c1;
  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  funid = camlidl_ml2c_manager_enum_ap_funid_t(_v_funid);
  funopt = &_c1;
  camlidl_ml2c_manager_struct_ap_funopt_t(_v_funopt, &_c1, _ctx);
  ap_manager_set_funopt(man, funid, funopt);
  camlidl_free(_ctx);
  return Val_unit;
}

value camlidl_manager_ap_manager_get_flag_exact(
	value _v_man)
{
  ap_manager_ptr man; /*in*/
  int _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  _res = ap_manager_get_flag_exact(man);
  _vres = camlidl_c2ml_manager_enum_tbool_t(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_manager_get_flag_best(
	value _v_man)
{
  ap_manager_ptr man; /*in*/
  int _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  _res = ap_manager_get_flag_best(man);
  _vres = camlidl_c2ml_manager_enum_tbool_t(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_manager_ap_manager_set_deserialize(
	value _v_man)
{
  ap_manager_ptr man; /*in*/
  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_manager_ap_manager_ptr(_v_man, &man, _ctx);
  ap_manager_set_deserialize(man);
  camlidl_free(_ctx);
  return Val_unit;
}

value camlidl_manager_ap_manager_get_deserialize(value _unit)
{
  ap_manager_ptr _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  _res = ap_manager_get_deserialize();
  _vres = camlidl_c2ml_manager_ap_manager_ptr(&_res, _ctx);
  camlidl_free(_ctx);
  return _vres;
}

